
var MAP_MAX_ZINDEX = 0;
var MAP_CONTROL_INDEX = 1000;
var MAP_DRAWING_INDEX = 999;
var MAP_POPUP_ZINDEX = 5000;

function objectClientPosition(obj) {
	var position = new Point(obj.offsetLeft, obj.offsetTop);
	var parent = obj.parentNode;

	while(parent && parent.tagName == 'DIV') {
		if(parent.offsetLeft) {
			position.x += parent.offsetLeft;
		}
		if(parent.offsetTop) {
			position.y += parent.offsetTop;
		}
		parent = parent.parentNode;
	}
	return position;
}

function GMap (EventManager) {
	var MySelf = this;
	var MapParent;
	var ImageParent = document.createElement('div');
	var ImageControl = document.createElement('input');
	var ImageImageMaps = document.createElement('map');
	ImageControl.type = 'Image';

	var ImageMapControl = document.createElement('img');
	ImageMapControl.src = BLANK_IMAGE;
	ImageMapControl.style.zIndex = MAP_CONTROL_INDEX - 1;

	ImageControl.src = BLANK_IMAGE;
	ImageControl.style.zIndex = MAP_CONTROL_INDEX;

	var FunctionOffset = new Point();
	var FunctionSemaphore = false;

	var DrawnPoints = new Array();
	var PreviousViews = new Array();
	var DrawBox = document.createElement('div');
	DrawBox.style.position = 'absolute';
	DrawBox.style.border = 'solid 2px red';
	DrawBox.style.zIndex = MAP_DRAWING_INDEX;
	DrawBox.style.visibility = 'hidden';


	var MapCenterPoint = new Point(576000, 157909.5);
	var MapScale = 25;


	var LayerURLs = new Array();
	var LayerImages = new Array();
	var LayerParameters = new Array();

	var min_z_index = MAP_MAX_ZINDEX;

	this.changePointScale = function(point,scale) {
		var circ = new Circle(point,scale);
		PreviousViews[PreviousViews.length] = circ;
		MapScale = scale;
		MapCenterPoint = point;
	}

	var LastActionTime = 0;

	this.setLastActionTime = function() {
		var d = new Date();
		LastActionTime = d.getTime();
		return LastActionTime;
	}

	this.getLastActionTime = function() {
		return LastActionTime;
	}


	/*
	 * This will refresh the map when a coordinate change happens
	 */
	this.onChangePointScale = function(psc) {
		PreviousViews[PreviousViews.length] = psc;
		MapScale = psc.Radius;
		MapCenterPoint = psc.Center;
		MySelf.refreshLayers();
	}

	/* Drawing Tools! */

	var DrawingShape = 'point';

	function startDrawing(event) {
		if(window.event) { event = window.event; }

		FunctionOffset = objectClientPosition(this);
		DrawnPoints = new Array();
		if(document.all) {	
			document.attachEvent("onmouseup", stopDrawing);
		} else {
			document.addEventListener("mouseup",stopDrawing,true);
		}
		if(DrawingShape == 'box' || DrawingShape=='evenbox') {
			DrawnPoints[0] = new Point(event.clientX-FunctionOffset.x, event.clientY-FunctionOffset.y);
		}
		MySelf.drawPoint(event.clientX-FunctionOffset.x, event.clientY-FunctionOffset.y);
		FunctionSemaphore = true;
	}

	function whileDrawing(event) {
		if(window.event) { event = window.event; }
		if(FunctionSemaphore) {
			MySelf.drawPoint(event.clientX-FunctionOffset.x, event.clientY-FunctionOffset.y);
		}
	}

	function whileDrawingBox(event) {
		if(window.event) { event = window.event; }
		if(FunctionSemaphore) {
			DrawBox.style.visibility = 'visible';
			var currentPoint = new Point(event.clientX-FunctionOffset.x, event.clientY-FunctionOffset.y);
			var left = DrawnPoints[0].x;
			var width = currentPoint.x - left;
			var top = DrawnPoints[0].y;
			var height = currentPoint.y - top;

			if(DrawingShape == 'evenbox') {
				if(width > height) { width = Math.abs(height) * width / Math.abs(width); }
				else { height = Math.abs(width) * height / Math.abs(height); }
			}

			if(width < 0) {
				left = left + width;
				width = -width;
			}

			if(height < 0) {
				top = top + height;
				height = -height;
			}

			DrawBox.style.top = top+'px';
			DrawBox.style.left = left+'px';
			DrawBox.style.height = height+'px';
			DrawBox.style.width = width+'px';
		}
	}
	
	function stopDrawing() {
		if (document.all) {
			document.detachEvent("onmouseup",   stopDrawing);
		} else {
			document.removeEventListener("mouseup",   stopDrawing, true);
		}

		if(FunctionSemaphore) {
			FunctionSemaphore = false;
			EventManager.triggerEvent('finishdrawing', DrawnPoints);
			DrawBox.style.visibility = 'hidden';
			DrawBox.style.left = '0px';
			DrawBox.style.top = '0px';
			DrawBox.style.height = '1px';
			DrawBox.style.width = '1px';
			for(var i = DrawnPoints.length; i >= 0; i--) {
				if(DrawnPoints[i] && DrawnPoints[i].parentNode) {
					var p = DrawnPoints[i].parentNode;
					p.removeChild(DrawnPoints[i]);
				}
			}
		}
	}

	this.mapStats = function() {
		logDebugMessage('Map Statistics', false, MapCenterPoint.toString(",")+' '+MapScale);
	}
	
	this.pointToGroundUnits = function(p) {
		p.x = (MapCenterPoint.x - (ImageControl.offsetWidth / 2 - p.x) * MapScale);
		p.y = (MapCenterPoint.y - (p.y - ImageControl.offsetHeight / 2) * MapScale);
		return p;
		
	}

	var DrawingArea = new Array();

	this.polyDrawTool = function(shape, title) {
		this.loadDrawTool('poly',true);
		EventManager.addEventListener('finishdrawing', 'MapZoomTool', function f() { 
			/* Ground Unit String is in WKT/GML Format */
			var groundUnitString = '';
			for(var i = 0; i < DrawnPoints.length; i++) {
				var p = new Point(DrawnPoints[i].offsetLeft,DrawnPoints[i].offsetTop);
				groundUnitString = groundUnitString + MySelf.pointToGroundUnits(p).toString(",") + ' ';
			}
			/* Close the polygon */
			if(shape == 'poly' || shape == 'circle') {
				groundUnitString = groundUnitString + MySelf.pointToGroundUnits(new Point(DrawnPoints[0].offsetLeft,DrawnPoints[0].offsetTop)).toString(",");
			}
			/*logDebugMessage('Points', false, groundUnitString);*/

			var pass = false;
			if(!title) {
				var msg = '';
				while(!pass) {
					title = prompt(msg+"Name for the object?", "Title");
					pass = true;
					if(LayerImages[title]) {
						pass = false;
						msg  = 'LAYER ALREADY EXISTS --';
					}
				}
				
			}

			if(title) {
				var bufferSize = prompt('Buffer Size?','0');
				if(!bufferSize) { bufferSize = 0; }
				
				/*var saveDrawingURL = '/mapscript/cgi-bin/saveDrawing.pl?coords=%COORDS%&shape=%SHAPE%&buffer=%BUFFER%&title=%TITLE%';*/
				var saveDrawingURL = DRAWING_URL;
				saveDrawingURL = saveDrawingURL.replace('%COORDS%', groundUnitString);
				saveDrawingURL = saveDrawingURL.replace('%SHAPE%', shape);
				saveDrawingURL = saveDrawingURL.replace('%BUFFER%', bufferSize);
				saveDrawingURL = saveDrawingURL.replace('%TITLE%', title);
				logDebugMessage('Drawing URL', false, saveDrawingURL);

				var titleCopy = title;

				var saveDrawingControl = getHTTPObject();
				saveDrawingControl.open('GET', saveDrawingURL, true);
				saveDrawingControl.onreadystatechange = function() {
					if(saveDrawingControl.readyState == 4) {
						/* Log the drawing area's ID and title for future use */
						DrawingArea[titleCopy] = trim(saveDrawingControl.responseText);
						MySelf.addDrawingLayer(titleCopy, trim(saveDrawingControl.responseText));
						/*alert(saveDrawingControl.responseText);*/
					}
				}
				saveDrawingControl.send(true);
			}
			title = '';
		});

	}

	this.getDrawingAreas = function() {
		return DrawingArea;
	}

	this.loadDrawTool = function(shape,override) {
		ImageControl.style.zIndex = MAP_CONTROL_INDEX;
		ImageMapControl.style.zIndex = MAP_CONTROL_INDEX - 1;

		if(!override) {
			EventManager.triggerEvent('changetool', 'Draw');
		}

		DrawingShape = shape;
		ImageControl.onmousedown = startDrawing;
		if(shape == 'box' || shape == 'evenbox') {
			ImageControl.onmousemove = whileDrawingBox;
		} else {
			ImageControl.onmousemove = whileDrawing;
		}
		ImageControl.onmouseup = stopDrawing;
	}


	ImageControl.onmousedown = function() {
	}

	ImageControl.onmouseup = function(event) {
		if(window.event) { event = window.event; }
		}

	function zoomWheel(event) {
		if(window.event) { event = window.event; }
		var dir = 2;
		var delta = 0;
		if(event.wheelDelta) {
			delta = event.wheelDelta/120;
		} else if(event.detail) {
			delta = -event.detail/3;
		}
		if(delta > 0) {
			dir = .7;
		} else if (delta < 0) {
			dir = 1.5;
		}
		MySelf.zoomTo(ZoomPoint.x, ZoomPoint.y, dir);
		
	}

	/*
	 * Zooming Related Code
	 */

	function zoomTrackMouse(event) {
		if(window.event) { event = window.event; }
		FunctionOffset = objectClientPosition(ImageControl);
		ZoomPoint.x = event.clientX - FunctionOffset.x;
		ZoomPoint.y = event.clientY - FunctionOffset.y;

	}
	var ZoomDirection = 1;
	var ZoomPoint = new Point();	
	function zoomToPoint(event) {
		if(window.event) { event = window.event; }
		FunctionOffset = objectClientPosition(ImageControl);
		//alert(FunctionOffset.toString(' '));
		MySelf.zoomTo(ZoomPoint.x, ZoomPoint.y, ZoomDirection);
	}
		

	this.loadZoomTool = function(v) {
		if(v == 1) { /* Pan */
			var PanPoint = new Point(0,0);
			ImageControl.onmousedown = function f(e) {
				if(window.event) { e = window.event; }
				ImageControl.Origin = new Point(e.clientX, e.clientY);
				for(var l in LayerImages) {
					LayerImages[l].originalLeft = LayerImages[l].offsetLeft;
					LayerImages[l].originalTop = LayerImages[l].offsetTop;
				}
				PanPoint.x = 0;
				PanPoint.y = 0;
			}
			ImageControl.onmouseup = function f(e) {
				if(window.event) { e = window.event; }
				MySelf.zoomTo(ImageControl.offsetWidth / 2 - PanPoint.x, ImageControl.offsetHeight / 2 - PanPoint.y, 1);
				/*delete ImageControl.Origin;*/
				ImageControl.Origin = null;
			}
			ImageControl.onmousemove = function f(e) {
				if(window.event) { e = window.event; }
				zoomTrackMouse(e);
				if(ImageControl.Origin) {
					for(var l in LayerImages) {
						LayerImages[l].style.left = LayerImages[l].originalLeft + (e.clientX - ImageControl.Origin.x) + 'px';
						LayerImages[l].style.top = LayerImages[l].originalTop + (e.clientY - ImageControl.Origin.y) + 'px';
					}
					PanPoint.x = e.clientX - ImageControl.Origin.x;
					PanPoint.y = e.clientY - ImageControl.Origin.y;
				}
				return false;
			}
		} else if(v < 1) { /* Zoom In */
			MySelf.loadDrawTool('box',true);
			ImageControl._onmousemove = ImageControl.onmousemove;
			ImageControl.onmousemove = function(event) {
				if(window.event) { event = window.event; }
				zoomTrackMouse(event);
				this._onmousemove(event);
			}
			EventManager.addEventListener('finishdrawing', 'MapZoomTool', function f() { 
				var Ratio = DrawBox.offsetWidth / ImageControl.offsetWidth;
				var hRatio = DrawBox.offsetHeight / ImageControl.offsetHeight;
				if(hRatio > Ratio) { Ratio = hRatio; }
				if(DrawBox.offsetWidth < 10) {
					MySelf.zoomTo(DrawnPoints[0].x, DrawnPoints[0].y, .7);
				} else {	
					MySelf.zoomTo(DrawBox.offsetLeft + DrawBox.offsetWidth / 2, DrawBox.offsetTop + DrawBox.offsetHeight / 2, Ratio);
				}
				/*EventManager.removeEventListener('finishdrawing','MapZoomTool');*/
			});
			EventManager.addEventListener('changetool', 'MapZoomTool', function f() {
				EventManager.removeEventListener('finishdrawing','MapZoomTool');
				EventManager.removeEventListener('changetool', 'MapZoomTool');
			});
		} else { /* Zoom Out */
			ImageControl.onmousedown = null;
			ImageControl.onmousemove = zoomTrackMouse;
			ImageControl.onmouseup = zoomToPoint;
		}

		ImageControl.style.zIndex = MAP_CONTROL_INDEX;
		ImageMapControl.style.zIndex = MAP_CONTROL_INDEX - 1;
		if(document.all) {
			ImageControl.onmousewheel = zoomWheel;
		} else {
			ImageControl.addEventListener('DOMMouseScroll', zoomWheel, false);
		}
		ZoomDirection = v;
	}
	


	this.clearLayerParams = function(mapTitle) {
		LayerParameters[mapTitle] = new Array();
	}

	this.addLayerParam = function(mapTitle,paramName,paramValue) {
		if(!LayerParameters[mapTitle]) { LayerParameters[mapTitle] = new Array(); }
		LayerParameters[mapTitle][paramName] = paramValue;
	}

	this.getLayerParamString = function(mapTitle) {
		if(!LayerParameters[mapTitle]) { return false; }
		var urlString = '';
		for(var p in LayerParameters[mapTitle]) {
			urlString = p+'='+LayerParameters[mapTitle][p]+'&';
		}
		return urlString;
	}

	this.addDrawingLayer = function(title,id) {
		var drawingMapFileTemplate = DRAWING_MAPFILE;
		MySelf.addLayerParam(title, 'ID', id);
		var mapXMLObj = document.createElement('map');
		var fileXMLObj = document.createElement('file');
		mapXMLObj.setAttribute('title', title);
		mapXMLObj.setAttribute('opacity', '50');
		mapXMLObj.appendChild(fileXMLObj);
		fileXMLObj.appendChild(document.createTextNode(drawingMapFileTemplate));
		EventManager.triggerEvent('addlayer', mapXMLObj);
	}

	this.addLayer = function (mapXMLObj) {
		var mapFile = mapXMLObj.getElementsByTagName('file')[0].firstChild.nodeValue;
		var mapTitle = mapXMLObj.getAttribute('title');
		var mapOpacity = mapXMLObj.getAttribute('opacity');

		mapFile = trim(mapFile);
		LayerURLs[mapTitle] = mapFile;/*+'?mode=map&mapext=%EXTENTS%&mapsize=%SIZE%';*/

		LayerImages[mapTitle] = document.createElement('img');
		LayerImages[mapTitle].style.position = 'absolute';
		LayerImages[mapTitle].id = 'LayerImage-'+mapTitle;
		if(mapOpacity) {
			setOpacity(LayerImages[mapTitle], mapOpacity);
		}
		

		var zIndex = mapXMLObj.getAttribute('zindex');
		if(!zIndex || zIndex > 0) {
			LayerImages[mapTitle].style.zIndex = MAP_MAX_ZINDEX;
			for(var title in LayerImages) {
				LayerImages[title].style.zIndex = parseInt(LayerImages[title].style.zIndex)-1;
			}
			min_z_index--;
		} else {
			min_z_index--;
			LayerImages[mapTitle].style.zIndex = min_z_index;
		}
		ImageParent.appendChild(LayerImages[mapTitle]);
		MySelf.autoFitLayer(mapTitle);
		LayerImages[mapTitle].onload = function() {
			MySelf.autoFitLayer(mapTitle);
			EventManager.triggerEvent('imagelayer', mapTitle);
		}

		var arr = new Array();
		arr[0] = mapTitle;
		MySelf.refreshLayer(arr);
	}

	this.confirmRemoveLayer = function(mapTitle) {
		MySelf.removeLayer(mapTitle);
	}

	this.removeLayer = function(mapTitle) {
		var imageMap = document.getElementById('ImageMap-'+mapTitle);
		if(imageMap) {
			var areas = imageMap.getElementsByTagName('area');
			for(var a = areas.length - 1; a >= 0; a--) {
				var p = areas[a].popup[0].parentNode;
				for(var pop = 0; pop < areas[a].popup.length; pop++) {
					p.removeChild(areas[a].popup[pop]);
				}
				imageMap.removeChild(areas[a]);
			}
			var p = imageMap.parentNode;
			p.removeChild(imageMap);
		}
		var p = LayerImages[mapTitle].parentNode;
		p.removeChild(LayerImages[mapTitle]);
		delete LayerImages[mapTitle];
		delete LayerURLs[mapTitle];
		if(DrawingArea[mapTitle]) {
			delete DrawingArea[mapTitle];
		}
	}

	this.getLayersByZIndex = function() {
		var orderedLayers = new Array();
		for(var title in LayerImages) {
			orderedLayers[orderedLayers.length] = title;
		}
		for(var i = 0; i < orderedLayers.length; i++) {
			for(var  j = i; j < orderedLayers.length; j++) {
				var iImage = LayerImages[orderedLayers[i]];
				var jImage = LayerImages[orderedLayers[j]];
				if(parseInt(iImage.style.zIndex) < parseInt(jImage.style.zIndex)) {
					var temp = orderedLayers[i];
					orderedLayers[i] = orderedLayers[j];
					orderedLayers[j] = temp;
				}
			}
		}
		return orderedLayers;
	}

	this.showOrderedLayers = function() {
		var str = '';
		var layers = this.getLayersByZIndex();
		for(var i = 0; i < layers.length; i++) {
			str = str+layers[i]+'('+LayerImages[layers[i]].style.zIndex+'),';
		}
	}
	
	this.shiftLayer = function(mapTitle, direction) {
		var orderedLayers = this.getLayersByZIndex();
		var selectedLayerIndex = -1;
		
		for(var i = 0; i < orderedLayers.length && selectedLayerIndex < 0; i++) {
			if(orderedLayers[i] == mapTitle) {
				selectedLayerIndex = i;
			}
		}
		if(selectedLayerIndex >= 0) {
			var baseImage = LayerImages[mapTitle];
			var targetImage = null; 
			/* Move the layer up, if it's not at the top*/
			if(direction > 0 && selectedLayerIndex > 0) {
				targetImage = LayerImages[orderedLayers[selectedLayerIndex-1]];
			/* Move the layer down, if it's not at the bottom */
			} else if(direction < 0 && selectedLayerIndex < orderedLayers.length - 1) {
				targetImage = LayerImages[orderedLayers[selectedLayerIndex+1]];
			}
			if(targetImage) {
				var tempIndex = baseImage.style.zIndex;
				baseImage.style.zIndex = targetImage.style.zIndex;
				targetImage.style.zIndex = tempIndex;
			}
		}
	}

	var REFRESH_LOCKOUT = false;

	this.zoomToScaledImage = function() {
		var orderedLayers = MySelf.getLayersByZIndex();
		/* zoomLayer will be Scaled to whatever the new image should be */
		var zoomLayer = LayerImages[orderedLayers[0]];
		var imageTop = zoomLayer.offsetTop;
		var imageLeft = zoomLayer.offsetLeft;

		var imageWidth = zoomLayer.offsetWidth;
		var imageHeight = zoomLayer.offsetHeight;

		/* ImageControl never changes size */
		var viewportTop = ImageControl.offsetTop;
		var viewportLeft = ImageControl.offsetLeft;
		var viewportWidth = ImageControl.offsetWidth;
		var viewportHeight = ImageControl.offsetHeight;

		/* Scale Change between the two images */
		var scale = viewportWidth / imageWidth * MapScale; 
		
		var groundTop = MapCenterPoint.y - MapScale * viewportHeight / 2;
		var groundLeft = MapCenterPoint.x - MapScale * viewportWidth / 2;

		/* Find the new Centerpoint in Pixel Space */
		var viewportMidX = (viewportLeft - imageLeft) + viewportWidth / 2;
		var viewportMidY = (viewportTop - imageTop) + viewportHeight / 2;
		var imagePercentX = viewportMidX / imageWidth;
		var imagePercentY = 1 - (viewportMidY / imageHeight);	

		var unscaledImageX = imagePercentX*viewportWidth;
		var unscaledImageY = imagePercentY*viewportHeight;

		/* Convert to ground units */
		var groundCenterX = groundLeft + unscaledImageX * MapScale;
		var groundCenterY = groundTop + unscaledImageY * MapScale;
		EventManager.changePointScale(new Point(groundCenterX, groundCenterY), scale);
	}
	
	this.zoomTo = function(x,y,direction) {
		if(REFRESH_LOCKOUT) return false;

		var orderedLayers = MySelf.getLayersByZIndex();
		var zoomLayer = LayerImages[orderedLayers[0]];
		var imgW = zoomLayer.offsetWidth;
		var imgH = zoomLayer.offsetHeight;

		var mapSize = MySelf.getMapSize();
		var diffY = ImageControl.offsetTop - zoomLayer.offsetTop;
		var diffX = ImageControl.offsetLeft - zoomLayer.offsetLeft;
		
		var PointImageX = diffX + x;
		var PointImageY = diffY + y;

		var wPercent = PointImageX / imgW;
		var hPercent = PointImageY / imgH;
		// Do some zooming tricks
		var imgSizeFactor = 1 / direction; // Inverse of the scale change
		var newW = imgSizeFactor * imgW;
		var newH = imgSizeFactor * imgH;

		var xLoc = x-(mapSize.x / 2);
		var yLoc = ((mapSize.y / 2) - y);

		var newScale = MapScale * newW / ImageControl.offsetWidth;
		if(newScale < .01) {
			return false;
		}
				
		if(direction != 1) {
			for(var layer in LayerImages) {
				var img = LayerImages[layer];
				//img.style.visibility = 'hidden';
				img.style.width = newW + 'px';
				img.style.height = newH + 'px';
				img.style.left = (newW * wPercent * -1 +  mapSize.x/2*0 + x)+'px';
				img.style.top = (newH * hPercent * -1 +  mapSize.y/2*0 + y)+'px';
				//img.style.visibility = 'visible';
			}
		}

		

		window.triggerMapRefresh = function(time) {
			REFRESH_LOCKOUT = true;
			if(time == LastActionTime) {
				MySelf.zoomToScaledImage();
				LastActionTime = 0;
			}
			REFRESH_LOCKOUT = false;
		}
		LastActionTime ++;
		setTimeout("window.triggerMapRefresh("+LastActionTime+")", 1000);
	}

		
	this.drawPoint = function(x,y) {
		var lastPoint = DrawnPoints[DrawnPoints.length-1];
		if(lastPoint) {
			var distx = (lastPoint.offsetLeft - x);
			var disty = (lastPoint.offsetTop - y);
			
			var dist = distx*distx + disty*disty;
			if(dist < 100) {
				return false;
			}
		}

		var newPoint = document.createElement('div');
		newPoint.style.position = 'absolute';
		newPoint.style.background = 'red';
		newPoint.style.border = 'none';
		newPoint.style.overflow = 'hidden';
		newPoint.style.width = '5px';
		newPoint.style.height = '5px';
		newPoint.style.left = x+'px';
		newPoint.style.top = y+'px';
		newPoint.className = 'DrawnPoint';
		DrawnPoints[DrawnPoints.length] = newPoint;
		ImageParent.appendChild(newPoint);
	}

	this.getMapSize = function() {
		var SizeObject = ImageControl;
		if(!SizeObject.offsetWidth) {
			SizeObject = MapParent;
		}
		var point = new Point(SizeObject.offsetWidth, SizeObject.offsetHeight);
		return point;
	}

	this.setParent = function(p) {
		MapParent = p;
		ImageParent.style.position = 'absolute';
		ImageParent.style.left = '0px';
		ImageParent.style.top = '0px';

		ImageControl.style.position = 'absolute';
		ImageControl.style.border = 'none';
		ImageControl.style.left = '0px';
		ImageControl.style.top = '0px';

		ImageMapControl.style.position = 'absolute';
		ImageMapControl.style.border = 'none';
		ImageMapControl.style.left = '0px';
		ImageMapControl.style.top = '0px';

		MapParent.appendChild(ImageParent);
		MapParent.appendChild(ImageControl);
		MapParent.appendChild(ImageMapControl);

		MapParent.appendChild(DrawBox);
		MapParent.style.overflow = 'hidden';

		this.autoFitLayers();	
	}

	this.refreshLayer = function(mapTitles) {
		var mapSize = MySelf.getMapSize();
		var gisOffsetW = mapSize.x / 2 * MapScale;
		var gisOffsetH = mapSize.y / 2 * MapScale;
		var minPoint = new Point(MapCenterPoint.x - gisOffsetW, MapCenterPoint.y - gisOffsetH);
		var maxPoint = new Point(MapCenterPoint.x + gisOffsetW, MapCenterPoint.y + gisOffsetH);
		var MapCoords = new LineSegment(minPoint,maxPoint);

		var http = getHTTPObject();
		var mySelf = this;
		var url = MAPCONTROL_URL; /*'/mapscript/cgi-bin/mapcontrol.pl?&extents=%EXTENTS%&size=%SIZE%';*/
		url = url.replace("%EXTENTS%",MapCoords.toString(" "));
		/*var extentString = minPoint.toString(" ")+" "+maxPoint.toString(" ");
		url = url.replace("%EXTENTS%", extentString);*/
		url = url.replace("%SIZE%", this.getMapSize().toString(" "));
		url = url.replace("%MAPBOOK%", MAPBOOK_FILE);
		url = url + '&center_point=' + MapCenterPoint.toString(" ");
		url = url + '&center_scale=' + MapScale;
		var extent = MapCoords.toString(" ");
		var size = this.getMapSize().toString(" ");


		for(var i = 0; i < mapTitles.length; i++) {
			url+='&map='+mapTitles[i];
			/*
			 * Do a little clean up on the Layer Image Maps 
			 */
			var imageMap = document.getElementById('ImageMap-'+mapTitles[i]);
			if(imageMap) {
				var areas = imageMap.getElementsByTagName('area');
				for(var a = areas.length - 1; a >= 0; a--) {
					var p = areas[a].popup[0].parentNode;
					for(var pop = 0; pop < areas[a].popup.length; pop++) {
						p.removeChild(areas[a].popup[pop]);
					}
					imageMap.removeChild(areas[a]);
				}
			}

			
			var imageURL = MAPSERVER_IMAGE_URL;
			imageURL = imageURL.replace("%EXTENTS%",extent);
			imageURL = imageURL.replace("%SIZE%", size);
			imageURL = imageURL.replace("%MAPFILE%", LayerURLs[mapTitles[i]]);
			var parameters = MySelf.getLayerParamString(mapTitles[i]);
			LayerImages[mapTitles[i]].src = imageURL+'&'+parameters;
			logDebugMessage('Image URL', false, imageURL);

			var dataURL = MAPSERVER_DATA_URL;
			dataURL = dataURL.replace("%EXTENTS%",extent);
			dataURL = dataURL.replace("%SIZE%", size);
			dataURL = dataURL.replace("%MAPFILE%", LayerURLs[mapTitles[i]]);
			dataURL = dataURL + '&' + parameters;
			this.loadData(mapTitles[i], dataURL);
			logDebugMessage('Data URL', false, dataURL);

			var legendURL = MAPSERVER_LEGEND_URL;
			legendURL = legendURL.replace("%EXTENTS%",extent);
			legendURL = legendURL.replace("%SIZE%", size);
			legendURL = legendURL.replace("%MAPFILE%", LayerURLs[mapTitles[i]]);
			legendURL = legendURL + '&' + parameters;
			var obj = document.createElement('layer');
			obj.setAttribute('legend', legendURL);
			obj.setAttribute('id',mapTitles[i]);
			EventManager.triggerEvent('legendlayer', obj);
		}

/*		http.open('GET', url, true); /* I don't want this to happen asynchronously */
/*		logDebugMessage('Map', false, url);
		http.onreadystatechange = function() {
			if(http.readyState == 4) {
				if(http.responseXML) {
					var resultDoc = http.responseXML;
					var layerElements = resultDoc.getElementsByTagName('layer');
					for(var layer = 0; layer < layerElements.length; layer++) {
						var map = layerElements[layer].getAttribute('map');
						var mapTitle = layerElements[layer].getAttribute('id');
*/
						/*LayerImages[mapTitle].src = map;*/
				/*		var data = layerElements[layer].getAttribute('data');
						var results = parseInt(layerElements[layer].getAttribute('results'));
						if(data && results > 0) {
							mySelf.loadData(mapTitle,data);
						}
						if(layerElements[layer].getAttribute('legend')) {
							EventManager.triggerEvent('legendlayer', layerElements[layer]);
						}
					}
				} else {
					logDebugMessage('Map', true, 'Error getting Response XML For: '+mapTitle);
				}
			}
		};
		http.send(true);*/
	}

	var Popups = new Array();
	this.getPopupData = function(i) {
		return Popups[i];
	}

	this.clearPopups = function() {
		var p = MapParent; //ImageControl.parentNode;
		var d = p.getElementsByTagName('div');
		for(var i = 0; i < d.length; i++) {
			if(d[i].className == 'Popup') {
				d[i].style.visibility = 'hidden';
			}
		}
	}

	this.loadData = function(id, dataCall) {
		var http = getHTTPObject();
		http.open('GET', dataCall, true);
		http.onreadystatechange = function() {
			if(http.readyState == 4) {
				if(http.responseXML) {
					var imageMap = document.createElement('map');
					var imageMapName = 'ImageMap-'+id;
					imageMap.id = imageMapName;
					if(document.all) {
						imageMap = document.createElement('<map name="'+imageMapName+'">');
					} else {
						imageMap.name = imageMapName;
					}
					var imageMapTest = document.getElementById(imageMapName);

					imageMap.className = 'ImageMaps';
					if(imageMapTest) { imageMap = imageMapTest; }

					var popups = http.responseXML.getElementsByTagName('popup');
					var offsetPoint = objectClientPosition(ImageControl);

					var styleObject = http.responseXML.getElementsByTagName('style')[0];
					var contentsFunction = function f() { };
					var titleFunction = function f() { };
					
					if(styleObject) {
						contentsFunction = getStyleFunction('contents', styleObject);
						titleFunction = getStyleFunction('title', styleObject);
					}
					var xCoord = new Array();
					var yCoord = new Array();
					var allShapes = new Array();

					var bin = new Array();
					for(var i = 0; i < popups.length; i++) {
						var coords = popups[i].getAttribute('coords');
							var coordsArr = coords.split(',');
							var found = false;

							for(var x in xCoord) {
								var w = Math.pow(xCoord[x] - coordsArr[0],2);
								var h = Math.pow(yCoord[x] - coordsArr[1],2);
								if(w+h < 49) {
									found = true;
									bin[x][bin[x].length] = popups[i];
								}
							}
							if(!found) {
								xCoord[coords] = coordsArr[0];
								yCoord[coords] = coordsArr[1];
								bin[coords] = new Array();
								bin[coords][0] = popups[i];
								allShapes[coords] = popups[i].getAttribute('shape');
							}

					}

					for(var b in bin) {
						var area = document.createElement('area');
						area.shape = allShapes[b];
						area.coords = b;

						area.popup = new Array();
						for(var i = 0; i < bin[b].length; i++) {
							var myPopup = document.createElement('div');
							myPopup.className = 'Popup';
							var myPopupTitle = document.createElement('div');
							myPopupTitle.appendChild(document.createTextNode(bin[b][i].getElementsByTagName('title')[0].firstChild.nodeValue));

							myPopup.appendChild(myPopupTitle);

							myPopup.draggable = new Draggable(myPopup, myPopupTitle, true,true,true);

							titleFunction(myPopupTitle);
							contentsFunction(myPopup);
							var items = bin[b][i].getElementsByTagName('item');

							for(var item = 0; item < items.length; item++) {
								var title = items[item].getAttribute('title');
								var val = '';
								if(items[item].firstChild) {
									val = items[item].firstChild.nodeValue;
								}
								var titleObj = document.createElement('span');
								titleObj.style.fontWeight = 'bold';
								var valObj = document.createElement('span');
								titleObj.appendChild(document.createTextNode(title));
								valObj.innerHTML = val;
								myPopup.appendChild(titleObj);
								myPopup.appendChild(valObj);
								myPopup.appendChild(document.createElement('br'));
							}

							var closeL = document.createElement('a');
							var closeImg = document.createElement('img');
							closeImg.src = REMOVE_ICON;
							closeL.appendChild(closeImg);
							closeL.style.position = 'absolute';
							closeL.style.right = '0px';
							closeL.style.top = '0px';
							closeImg.style.width = '8px';
							closeImg.style.height = '8px';

							closeL.onclick = function f() {
								this.parentNode.style.visibility = 'hidden';
								this.area.onmouseup();
							}
							myPopup.appendChild(closeL);
							ImageControl.parentNode.appendChild(myPopup);
							area.popup[area.popup.length] = myPopup;
							closeL.area = area;
						}
						area.onmousemove = function f(event) {  
							if(window.event) { event = window.event; }
							var mouseY = event.clientY-offsetPoint.y;
							var mouseX = event.clientX-offsetPoint.x;
							var offsetX = 4;
							var offsetY = 4;
							for(var i = 0; i < this.popup.length; i++) {
								this.popup[i].style.zIndex =  MAP_POPUP_ZINDEX;
								/*if(mouseY + this.popup[i].offsetHeight < ImageControl.offsetHeight) {*/
								if(mouseY < ImageControl.offsetHeight / 2) {
									this.popup[i].style.top = mouseY+offsetY+'px';
									this.popup[i].style.bottom = 'auto';
								} else {
									this.popup[i].style.bottom = (ImageControl.offsetHeight - mouseY)+offsetY+'px';
									this.popup[i].style.top = 'auto';
								}
								/*if(mouseX + this.popup[i].offsetWidth < ImageControl.offsetWidth) {*/
								if(mouseX < ImageControl.offsetWidth /2 ) {
									this.popup[i].style.left = mouseX+offsetX+'px';
									this.popup[i].style.right = 'auto';
								} else {
									this.popup[i].style.right = (ImageControl.offsetWidth - mouseX)+offsetX+'px';
									this.popup[i].style.left = 'auto';
								}

								this.popup[i].style.visibility = 'visible';
								offsetY += 10;
								offsetX += 10;
							}
						}
						area.onmouseup = function () {
							if(this.onmouseout) {
								this._onmouseout = this.onmouseout;
								this.onmouseout = null;
							} else {
								this.onmouseout = this._onmouseout;
								this._onmouseout = null;
							}
						}
		
						area.onmouseout = function f(event) {
							for(var i = 0; i < this.popup.length; i++) {
								this.popup[i].style.visibility = 'hidden';
							}
						}
						imageMap.appendChild(area);
					}
					if(!imageMapTest) {
						document.getElementsByTagName('body')[0].appendChild(imageMap);
					}
					if(popups.length > 0) {
						EventManager.triggerEvent('datalayer',id);
					}
				}
			}
		}
		http.send(true);
	}

	this.activateLayer = function(mapTitle) {
		var imageMapName = 'ImageMap-'+mapTitle;
		ImageMapControl.setAttribute('usemap', '#'+imageMapName);
		ImageMapControl.setAttribute('useMap', '#'+imageMapName);
		ImageMapControl.ismap = true;
		ImageMapControl.style.zIndex = MAP_CONTROL_INDEX;
		ImageControl.style.zIndex = MAP_CONTROL_INDEX - 1;
	}



	this.autoFitLayers = function() {
		var mapSize = new Point(MapParent.offsetWidth, MapParent.offsetHeight);
		ImageParent.style.width = mapSize.x+'px';
		ImageParent.style.height = mapSize.y+'px';
		for(var title in LayerImages) {
			this.autoFitLayer(title);
		}
		ImageControl.style.width = mapSize.x+'px';
		ImageControl.style.height = mapSize.y+'px';
		ImageMapControl.style.width = mapSize.x+'px';
		ImageMapControl.style.height = mapSize.y+'px';

	}

	this.autoFitLayer = function(mapTitle) {
		var mapSize = this.getMapSize();
		this.resizeLayer(mapTitle,mapSize.x,mapSize.y);
	}

	this.resizeLayer = function(mapTitle,w,h) {
		//LayerImages[mapTitle].style.visibility = 'hidden';
		LayerImages[mapTitle].style.top = '0px';
		LayerImages[mapTitle].style.left = '0px';
		LayerImages[mapTitle].style.width = w+'px';
		LayerImages[mapTitle].style.height = h+'px';
		//LayerImages[mapTitle].style.visibility = 'visible';
	}

	this.refreshLayers = function() {
		var arr = new Array();
		for(var title in LayerImages) {
			//EventManager.triggerEvent('refreshlayer', title);
			arr[arr.length] = title;
		}
		MySelf.refreshLayer(arr);
	}

	function getStyleFunction(tagType, styleXML) {
		if(!styleXML) { return function(obj) { }; }
		var tag = styleXML.getElementsByTagName(tagType);
		var evalString = '';

		for(var t = 0; t < tag.length; t++) {
			var attrs = tag[t].getElementsByTagName('attr');
			for(var a = 0; a < attrs.length; a++) {
				evalString += ('obj.style.'+attrs[a].getAttribute('name')+'="'+attrs[a].getAttribute('value')+'";');
			}
		}	
		return function(obj) { eval(evalString); };
	}

	this.moveLayerUp = function(title) {
		MySelf.shiftLayer(title, 1);
	}

	this.moveLayerDown = function(title) {
		MySelf.shiftLayer(title, -1);

	}

	this.changeLayerOpacity = function(layerName, amount) {
		var img = LayerImages[layerName];
		var opac = getOpacity(img);
		opac+=amount;
		setOpacity(img, opac);
	}

	this.fadeLayer = function(title) {
		MySelf.changeLayerOpacity(title, -10);
	}

	this.unfadeLayer = function(title) {
		MySelf.changeLayerOpacity(title, 10);
	}

	this.reloadLayer = function(title) {
		var arr = new Array();
		arr[0] = title;
		MySelf.refreshLayer(arr);	
	}
	
}
