function ServiceForm (EventManager, serviceXMLObj, serviceMap) {

	function createInputArray(table) {
		var inputs = table.getElementsByTagName('input');
		var inputValues = new Array();
		for(var i = 0; i < inputs.length; i++) {
			inputValues[inputs[i].name] = inputs[i].value;
		}

		var selects = table.getElementsByTagName('select');
		for(var i = 0; i < selects.length; i++) {
			var options = selects[i].getElementsByTagName('option');
			inputValues[selects[i].name] = options[selects[i].selectedIndex].value;
		}
		return inputValues;
	}

	this.setParent = function(p) {
		var formTable = document.createElement('table');
		var formBody = document.createElement('tbody');
		formTable.appendChild(formBody);

		var inputs = serviceXMLObj.getElementsByTagName('input');
		for(var i = 0; i < inputs.length; i++) {
			var newInputRow = document.createElement('tr');
			var inputTitleCell = document.createElement('th');
			inputTitleCell.appendChild(document.createTextNode(inputs[i].getAttribute('title')));

			var newInputCell = document.createElement('td');
			newInputRow.appendChild(inputTitleCell);
			newInputRow.appendChild(newInputCell);
			formBody.appendChild(newInputRow);
			if(inputs[i].getAttribute('type').match(/user/i)) {
				var inputObj = document.createElement('input');
				if(inputs[i].getAttribute('value')) {
					inputObj.value = inputs[i].getAttribute('value');
				}

				inputObj.name = inputs[i].getAttribute('name');
				inputObj.setAttribute('subtype', 'user');

				newInputCell.appendChild(inputObj);
			} else if(inputs[i].getAttribute('type').match(/select/i)) {
				var selectObj = document.createElement('select');
				selectObj.name = inputs[i].getAttribute('name');
				selectObj.setAttribute('subtype', 'select');
				var options = inputs[i].getElementsByTagName('option');
				for(var o = 0; o < options.length; o++ ) {
					var option = document.createElement('option');
					option.value = options[o].getAttribute('value');
					option.appendChild(document.createTextNode(options[o].firstChild.nodeValue));
					selectObj.appendChild(option);
				}
				newInputCell.appendChild(selectObj);

			} else if(inputs[i].getAttribute('type').match(/hidden/i)) {
				var newInput = document.createElement('input');
				newInput.type = 'hidden';
				newInput.name = inputs[i].getAttribute('name');
				newInput.value = inputs[i].getAttribute('value');
				newInput.setAttribute('subtype','user');
				/*inputsTable.appendChild(newInput);*/
				formTable.appendChild(newInput);
			} else if(inputs[i].getAttribute('type').match(/area/i)) {
				var selectObj = document.createElement('select');
				selectObj.name = inputs[i].getAttribute('name');
				selectObj.setAttribute('subtype', 'select');
				var areas = serviceMap.getDrawingAreas();
				for(var area in areas) {
					var option = document.createElement('option');
					option.value = areas[area];
					option.appendChild(document.createTextNode(area));
					selectObj.appendChild(option);
				}
				newInputCell.appendChild(selectObj);
			}
		}

		var cancelSubmitRow = document.createElement('tr');

		var cancelButton = document.createElement('button');
		cancelButton.appendChild(document.createTextNode('Cancel'));
		var searchButton = document.createElement('button');
		searchButton.appendChild(document.createTextNode('Search'));

		var cancelCell = document.createElement('td');
		var searchCell = document.createElement('td');
		cancelCell.appendChild(cancelButton);
		searchCell.appendChild(searchButton);
		cancelSubmitRow.appendChild(cancelCell);
		cancelSubmitRow.appendChild(searchCell);
		formBody.appendChild(cancelSubmitRow);

		cancelButton.onclick = function() {
			EventManager.triggerEvent('cancelservice', serviceXMLObj);
		}

		searchButton.onclick = function () {
			var values = createInputArray(formTable);
			var url = serviceXMLObj.getElementsByTagName('url')[0].firstChild.nodeValue;
			url += '?';

			for(var v in values) {
				url+=v+'='+escape(values[v])+'&';
			}
			/*alert(url);*/
			
		}

		/* Only "Search" type services get rendered in a special window, everything else is an external call */
		/*if(serviceXMLObj.getAttribute('type') && serviceXMLObj.getAttribute('type').match(/search/i)) {*/
			searchButton.onclick = function () {
				var values = createInputArray(formTable);
				var inputs = serviceXMLObj.getElementsByTagName('input');
				for(var i = 0; i < inputs.length; i++) {
					inputs[i].setAttribute('value', values[inputs[i].getAttribute('name')]); 
				}
				/*var inputs = serviceXMLObj.getElementsByTagName('input');
				for(var i = 0; i < inputs.length; i++) {
					p.appendChild(document.createTextNode(inputs[i].getAttribute('name')+'='+inputs[i].getAttribute('value')));
					p.appendChild(document.createElement('br'));
				}*/
				EventManager.triggerEvent('callservice', serviceXMLObj);
			}
		/*}*/
		p.appendChild(formTable);

	}
}
